package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingMercadoDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingMercado;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.service.GP_PricingMercadoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingMercadoService")
public class GP_PricingMercadoServiceImpl implements GP_PricingMercadoService {

    @Autowired
    private GP_PricingMercadoDAO pricingMercadoDAO;

    public List<GP_PricingMercado> obtenerTodos() {
        return pricingMercadoDAO.obtenerTodos();
    }

    public GP_PricingMercado obtenerID(Integer id) {
        return pricingMercadoDAO.obtenerID(id);
    }

    @Transactional
    public GP_PricingMercado suscribir(GP_PricingMercado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingMercadoDAO.suscribir(entidad);
    }

    @Transactional
    public GP_PricingMercado actualizacion(GP_PricingMercado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingMercadoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(GP_PricingMercado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.EXCLUIDO);

        pricingMercadoDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingMercado(GP_Pricing pricing, Parada origen, Parada destino) {
        return pricingMercadoDAO.obtenerPricingMercado(pricing, origen, destino);
    }

	@Override
	public List<GP_PricingMercado> obtenerTodoPorPricing(GP_Pricing pricing) {
		return pricingMercadoDAO.obtenerTodoPorPricing(pricing);
	}
}
